/////////////////////////////////////////////////////////////////////////////
//
// Copyright(C) 2002 Mitsuhiro Shirai
// E-mail shirai@as.email.ne.jp
//
// Last update	2002.12.10	SDKްޮ
//
// DateEx.h	CDateEx NX̐錾уC^[tF[X̒`܂D
// ̃NX͓ti{jň߂̃NXłD
//
//////////////////////////////////////////////////////////////////////////////

#pragma once 

#include <windows.h>
#include <stdio.h>


// ǗoJnNƏINiH/t̓Ǘł͈́j
#define	CDATEEX_STARTYY			1994
#define	CDATEEX_ENDYY			2050

// Format ꂽt̍ő咷i߁j
#define	DATEEX_FORMAT_STR_MAX	32
// jՓ̍ő咷i߁j
#define	HOLIDAY_STR_MAX			32

// NX`
class	CDateEx
{
public:

	// RXgN^EfXgN^
	CDateEx(INT inYY,INT inMM,INT inDD);
	CDateEx(LONG inJullanSerial = 0);
	CDateEx(CHAR* inYmd,INT inYPos,INT inMPos,INT inDPos); // Pos  0`
	virtual	~CDateEx();
		
	// X^eBbNiisLeapYear / LastDay ̓CCj

	// yyyy.mm.dd  VAf[g t̑Ó̓`FbNς݂ł邱
	static	LONG Ymd2JullanSerial(
					INT inYY,INT inMM,INT inDD);
	// VAf[g  yyyy.mm.dd
	static	void JullanSerial2Ymd(
					LONG inJullanSerial,
					INT* outYY,INT* outMM,INT* outDD);
	// [N`FbNi[N̏ꍇ TRUEj
	static	BOOL isLeapYear(
					INT inYY)
					{return ((!(inYY%4) && (inYY%100) || !(inYY%400)));};
	// jo(o̓obt@͂RBytesȏp)
	static	CHAR *	GetYoubiStr(
						INT		inYoubi,
						CHAR *	outYoubiStr);	
												
	// yyyy.mm ̌߂
	static	INT LastDay(
					INT inYY,INT inMM)
					{
						INT	theLastDay = 31;
						switch(inMM)	{
							case 2:
								theLastDay = 28;
								if(isLeapYear(inYY))	theLastDay++;
								break;
							case 4: case 6: case 9: case 11:
								theLastDay = 30;	
								break;
						}
						return theLastDay;
					};

	// ̏o͂ɂOt邩ǂ̃tO
	enum	{	zeroYM		= TRUE,
				not_zeroYM	= FALSE
			};
	
	// j
	enum	{SUN=0,MON,TUE,WEN,THU,FRI,SAT};
	
	// Format ł̏o̓tH[}bgp^[iZp[^ inSeparate Ɉˑj
	enum	{	yyyymmdd = 0,			/* YYYYMMDD					*/
				yymmdd,					/* YYMMDD					*/
				yyyy_mm_dd,				/* yyyy/mm/dd				*/
				yy_mm_dd,				/* yy/mm/dd					*/
				Jyyyy_mm_dd,			/* yyyyNmmdd			*/
				Jyyyy_mm_ddw,			/* yyyyNmmdd[j]			*/
				Jyyyy_mm_ddw_n,			/* yyyyNmmdd[xj]	*/
				Jyy_mm_dd,				/* yyNmmdd				*/
				Jyy_mm_ddw,				/* yyNmmdd[j]			*/
				Jyy_mm_ddw_n,			/* yyNmmdd[xj]	*/
				Jyy_mm					/* yyNmm					*/
			};
	
	// xUւ̃[h
	enum	{	NotTransfer = 0,		/* Uւ			*/
				Hday_PreviousDay,		/* x̏ꍇ͑O		*/
				Hday_NextDay			/* x̏ꍇ͎̓	*/
			};
	enum	{	SAT_NotToHave = FALSE,	/* Uւɓyj͊܂܂Ȃ	*/
				SAT_ToHave = TRUE		/* Uւɓyj܂		*/
			};

	// o\bh

	BOOL	isVarid()	const	
			{
				return 	((m_JullanSerial >= 0)		&&
						 (m_yy >= 1)				&&
						 (m_mm >= 1 && m_mm <= 12)	&&
						 (m_dd >= 1 && m_dd <= LastDay(m_yy,m_mm)) );
			};											// tLǂ

	BOOL	isWarning()	const	
			{
				return ( (m_yy < CDATEEX_STARTYY) ||
						 (m_yy > CDATEEX_ENDYY) );
			};											// tH̓Lǂ

	BOOL	isFurikae()
			{
				BOOL	result = FALSE;
				if ((m_youbi == MON) && (this->Holiday() == 0))	{
					CDateEx	theBackDay(m_JullanSerial-1);
					result = theBackDay.Holiday();
				}
				return result;
			};											// U֋x

	LONG JullanSerial()
				const	{return m_JullanSerial;};		// VAf[go

	INT	year()	const	{return m_yy;};			// No
	INT	month()	const	{return m_mm;};			// o
	INT	day()	const	{return m_dd;};			// o
	INT	youbi()	const	{return m_youbi;};		// jo

												// 扽jo
	INT	NoOfWeek()	const
			{
				CDateEx	theWkYmd = m_JullanSerial;
				INT	theCount = 0;
				if (isVarid())	{
					while (theWkYmd.month() == m_mm)	{
						if (theWkYmd.youbi() == m_youbi)	theCount++;
						theWkYmd -= 7;
					}
				}
				return theCount;
			};								

	virtual CHAR *	youbiStr(
						CHAR * outYoubiStr);	// jo
												// o̓obt@͂RBytesȏp
	BOOL	isLeap()	const
				{return isLeapYear(m_yy);};		// [N̏ꍇ TRUE
	
	BOOL	isLastDay()	const
				{return (LastDay(m_yy,m_mm) == m_dd);};		// ̏ꍇ TRUE

	INT	thisLastDay()	const
				{return LastDay(m_yy,m_mm);};	// ̓t̖o


	// tH[}bgďóio̓obt@GÃ`FbN͍sĂȂj
	virtual CHAR * Format(
				CHAR * outYmd,
				INT	inFormatNo = yyyymmdd,
				BOOL	inZero = zeroYM,
				CHAR	inSeparate = '/');	
	
	// `FbNp̃\bh
	virtual INT	Holiday();					// jՓǂ`FbNi0>:jՓj
	virtual CHAR *	HolidayStr(
				CHAR * outYoubiStr);			// jՓo
												// io̓obt@GÃ`FbN͍sĂȂj
	BOOL Between(
				CDateEx & inFromDate,
				CDateEx & inToDate);			// From To ͈̔͂Ɂi܂ށjɂꍇ TRUE
				
	// tύX郁\bh
	virtual BOOL	DoFurikae(
			INT	inMode,
			BOOL	isSatDayToCntain = SAT_ToHave);	// xUւ@Uւ TRUE
	void	DoNextMonth();							// Ɂȉꍇ͕␳j
	void	DoBackMonth();							// OɁȉꍇ͕␳j
	void	DoNextYear();							// NɁȉꍇ͕␳j
	void	DoBackYear();							// ONɁȉꍇ͕␳j
	void	GotoFirstDay();							// 
	void	GotoLastDay();							// 
	
	// Zq̃I[o[[fBO
	// 
	CDateEx&		operator =	(LONG	inJullanSerial)
			{
				m_JullanSerial = inJullanSerial;
				SyncVariable();
				return *this;
			};
	CDateEx&		operator =	(CDateEx&	inDate)
			{
				m_JullanSerial = inDate.JullanSerial();
				SyncVariable();
				return *this;
			};
	
	// Z
	CDateEx&		operator +=	(LONG	inDays)	
			{
				m_JullanSerial += inDays;
				SyncVariable();
				return *this;
			};
	CDateEx&		operator -=	(LONG	inDays)
			{
				m_JullanSerial -= inDays;
				SyncVariable();
				return *this;
			};
	CDateEx&		operator ++	(INT)	
			{
				m_JullanSerial++;
				SyncVariable();
				return *this;
			};
	CDateEx&		operator --	(INT)
			{
				m_JullanSerial--;
				SyncVariable();
				return *this;
			};
					
	// r
	BOOL		operator ==	(const CDateEx& inDate)
			{
				return (m_JullanSerial == inDate.JullanSerial());
			};
	BOOL		operator !=	(const CDateEx& inDate)
			{
				return (m_JullanSerial != inDate.JullanSerial());
			};
	BOOL		operator >	(const CDateEx& inDate)
			{
				return (m_JullanSerial > inDate.JullanSerial());
			};
	BOOL		operator <	(const CDateEx& inDate)
			{
				return (m_JullanSerial < inDate.JullanSerial());
			};
	BOOL		operator >=	(const CDateEx& inDate)
			{
				return (m_JullanSerial >= inDate.JullanSerial());
			};
	BOOL		operator <=	(const CDateEx& inDate)
			{
				return (m_JullanSerial <= inDate.JullanSerial());
			};

protected:

	// LT̃NXϐ͕KĂi!m_isVarid ̏ꍇ͊el͂OɂȂĂj
	// ͑S SyncVariable ōs
	INT	m_yy;					// N
	INT	m_mm;					// 
	INT	m_dd;					// 
	INT	m_youbi;				// j
	LONG	m_JullanSerial;			// VAf[g
	// NXϐ
	void Initial();			
	// NXϐ𓯊
	void SyncVariable();	// m_JullanSerial ɂ킹				
	void SyncVariable(
			INT inYY,
			INT inMM,
			INT inDD);	// yyyy.mm.dd ɂ킹
	
	// VAf[gjiēj͂܂Ă񂾂ˁj
	INT	JullanSerial2Youbi(
				LONG in_JullanSerial)
			{return (in_JullanSerial % 7);};	

};

